<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2009 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: autonews_include.php (autonews v1.0)
| Author: flj (Flemming Jensen)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

define("AUTONEWS_STATUS_WAIT", 0);
define("AUTONEWS_STATUS_SEND", 1);

// Locale
if (file_exists(INFUSIONS."autonews/locale/".$settings['locale'].".php")) 
{ 
  include INFUSIONS."autonews/locale/".$settings['locale'].".php"; 
} 
else 
{
	include INFUSIONS."autonews/locale/English.php";
}
require_once INFUSIONS."autonews/infusion_db.php";
include INFUSIONS."autonews/autonews_params.php"; 

// Global vars
global $autonews_data;

// Does what has to be done at all times - returns TRUE if something has happened
function autonews()
{
  $autonews_settings = autonews_readdb();
  if ($rtn = autonews_check($autonews_settings))
  {
    autonews_send($autonews_settings);
  }
  return $rtn;
}

// Returns TRUE if newsmail needs to be send or are being send
function autonews_check(&$autonews_settings)
{
  return !bit_isset($autonews_settings['include'], 0) && // Not disabled
         $autonews_settings['frequency'] > 0 && // Not 'never'
         (($autonews_settings['status'] == AUTONEWS_STATUS_WAIT && $autonews_settings['ts_thissend'] + $autonews_settings['frequency'] < time()) || // Time for a new mail 
          ($autonews_settings['status'] == AUTONEWS_STATUS_SEND && $autonews_settings['ts_lastchunk'] + $autonews_settings['senddelay'] < time()) // Sending is ongoing
         );
}

// Reads the database settings
function autonews_readdb()
{
  global $locale, $settings;
	global $autonews_data;
  
  $autonews_settings = dbarray(dbquery("SELECT * FROM ".DB_AUTONEWS." LIMIT 1;"));
  require_once INFUSIONS."autonews/autonews_data.php";

  return $autonews_settings;
}

// Sends a news mail
function autonews_send(&$autonews_settings)
{
	global $autonews_params;
	
  // Prepare for a new 'send'
  if ($autonews_settings['status'] == AUTONEWS_STATUS_WAIT)
  {
    // Update settings
    $autonews_settings['status'] = AUTONEWS_STATUS_SEND;
    $autonews_settings['ts_thissend'] = time();
    $autonews_settings['ts_lastchunk'] = 0;
    $autonews_settings['message_subject'] = stripinput(createsubject($autonews_settings));
    $autonews_settings['message_body'] = stripinput(createbody($autonews_settings));
    
    // Identify receivers
    $autonews_settings['no_receivers'] = reclist_set();
  }
  
  // Send
  if ($autonews_settings['message_body'] != '')  
  {
    require_once INCLUDES."sendmail_include.php";
  
    $from_user = '';
    $from_mail = fromemail();
    $to = reclist_get($autonews_settings['chunksize'], TRUE);

		$n = count($to);
    if ($n > 0) { sendemail('', $autonews_params['copyemail'], $from_user, $from_mail, html_entity_decode($autonews_settings['message_subject'], ENT_QUOTES), html_entity_decode($autonews_settings['message_body'], ENT_QUOTES), "html", '', implode(',', $to)); }

    $autonews_settings['ts_lastsend'] = $autonews_settings['ts_thissend'];
    $autonews_settings['ts_lastchunk'] = time();
    if ($n < $autonews_settings['chunksize']) { $autonews_settings['status'] = AUTONEWS_STATUS_WAIT; }    
  }
  else
  {
    $autonews_settings['status'] = AUTONEWS_STATUS_WAIT;
  }

  autonews_updatedb($autonews_settings);
}

// Update database with new status settings
function autonews_updatedb(&$autonews_settings)
{
  dbquery("UPDATE ".DB_AUTONEWS." SET
                  status = '".$autonews_settings['status']."',
                  ts_thissend = '".$autonews_settings['ts_thissend']."',
                  ts_lastsend = '".$autonews_settings['ts_lastsend']."',
                  ts_lastchunk = '".$autonews_settings['ts_lastchunk']."',
                  no_receivers = '".$autonews_settings['no_receivers']."',
                  message_body = '".$autonews_settings['message_body']."',
                  message_subject = '".$autonews_settings['message_subject']."';");
}

// View message
function autonews_view(&$autonews_settings, $test = FALSE, $to = FALSE)
{
  global $settings, $aidlink, $locale;
  
  if ($test)
  {
  	$date = time();
	  $subject = createsubject($autonews_settings); 
	  $body = createbody($autonews_settings);
		$no_receivers = reclist_count(); 
	}
	else
	{
		$date = $autonews_settings['ts_thissend'];
		$no_receivers = $autonews_settings['no_receivers'];
		$body = html_entity_decode($autonews_settings['message_body'], ENT_QUOTES);
    $subject = html_entity_decode($autonews_settings['message_subject'], ENT_QUOTES);
	}
	
	if ($body == '')
	{
		$subject = $locale['AN161'];
	}

	$to_count = "<a href='".INFUSIONS."autonews/autonews_view.php".$aidlink."&test=".$test."&to=".!$to."' target='_self'>".($to? '-': '+').sprintf($locale['AN155'], reclist_count())."</a>";
		
	$to_list = array();
	
	if ($to)
	{
		// When showing the last message, this list may be inaccurate, to the extent changes in subscribers list has happened since sending
		$result = dbquery("SELECT user_name, user_email FROM ".DB_USERS." WHERE user_autonews = '1' ORDER BY user_name;");
		while ($data = dbarray($result))
		{
			$to_list[] = $data['user_name']."&lt;".$data['user_email']."&gt;";
		}
	}

  echo("<table>");
  echo("<tr><td>".$locale['AN151'].":</td><td>".$settings['siteusername']."&lt;".fromemail()."&gt;;</td></tr>");
  echo("<tr><td>".$locale['AN152'].":</td><td>".$to_count."</td></tr>");
  echo("<tr><td></td><td>".implode("<br />", $to_list)."</td></tr>");
  echo("<tr><td>".$locale['AN153'].":</td><td>".date($locale['AN010'], $date)."</td></tr>");
  echo("<tr><td>".$locale['AN154'].":</td><td>".$subject."</td></tr>");
  echo("<tr><td colspan='2'><hr></td></tr>");
  echo("<tr><td colspan='2'>".$body."</td></tr>");
  echo("</table>");
}

// Writes admin settings to the database
function autonews_writedb(&$autonews_settings)
{
  dbquery("UPDATE ".DB_AUTONEWS." SET 
                  frequency = '".$autonews_settings['frequency']."',
                  include = '".$autonews_settings['include']."',
                  maxlen = '".$autonews_settings['maxlen']."',
                  minno = '".$autonews_settings['minno']."',
                  maxno = '".$autonews_settings['maxno']."',
                  banner_top = '".$autonews_settings['banner_top']."',
                  banner_bottom = '".$autonews_settings['banner_bottom']."',
									chunksize = '".$autonews_settings['chunksize']."',
                  senddelay = '".$autonews_settings['senddelay']."';");
}

// Utility function to create the news message body
function createbody(&$autonews_settings)
{
  global $settings, $locale;
  global $autonews_data;
  
  // Prepare...
  $new_type = array();
  $new_time = array();
  $new_text = array();

  // Loop all defined data-retrievers
  foreach($autonews_data as $item)
  {
    // Execute, if include-bit is checked
    if (bit_isset($autonews_settings['include'], $item['id']))
    {
      if ($result = dbquery($item['query']))
      {
        // Loop over all queried lines (or until we have what we need)
        for ($i = 0; ($data = dbarray($result)); $i++)
        {
          // Parse data
          $t1 = ($item['parse1'] == ''? '': eval($item['parse1']));
          $t2 = ($item['parse2'] == ''? '': eval($item['parse2']));
          // Save in arrays
          $new_type[] = $item['id'];
          $new_time[] = $data['timestamp'];
          $new_text[] = sprintf($item['text'],
                                date($locale['AN010'], $data['timestamp']),
                                pagelink('U', $data['user_id'], $data['user_name']),
                                $data['item_no'],
                                $t1,
                                $data['item2_no'],
                                $t2);
        }
      }
    }
  }
  
  // Build message
  $message = msgformat($autonews_settings, $new_type, $new_time, $new_text); 
  
  return $message;
}

function createsubject(&$autonews_settings)
{
  global $settings, $locale;

  return sprintf($locale['AN112'], $settings['sitename']);
}

// Utility function to return the email of the sender (from)
function fromemail()
{
	global $autonews_params, $settings;
	
	return $autonews_params['fromemail'] == ''? $settings['siteemail']: $autonews_params['fromemail'];	
}

// Utility function to format the message
function msgformat(&$autonews_settings, &$new_type, &$new_time, &$new_text)
{
  global $settings, $locale;
  global $autonews_params;

  $msg = '';

  // Only output if at least minno lines
  if (count($new_text) >= $autonews_settings['minno'])
  {
    // Message header
    $msg .= $autonews_params['html_start']."<p>";
    if ($autonews_settings['banner_top'] <> '' && file_exists(IMAGES.$autonews_settings['banner_top'])) $msg .= "<p><img src='".$settings['siteurl']."images/".$autonews_settings['banner_top']."' /></p>";
    $msg .= sprintf($locale['AN111'], "<a href='".$settings['siteurl']."'><strong>".$settings['sitename']."</strong></a>");
    $msg .= "</p><p>".$locale['AN113']."</p>";

    // Sort all outputs in descending date order
    array_multisort($new_time, SORT_DESC, $new_type, $new_text);

    // Output max maxno lines (leave one line for 'summing up' if needed)
    if (count($new_text) > $autonews_settings['maxno'])
    {
      $n = $autonews_settings['maxno'] - 1;
      $summary = TRUE;
    }
    else
    {
      $n = count($new_text);
      $summary = FALSE;
    }

    // Output lines
    $msg .= "<ul>";
    for ($i = 0; $i < $n; $i++)
    { 
      $msg .= "<li>".$new_text[$i]."</li><br />";
    }
    // Output summary, if required
    if ($summary) $msg .= "<li>".msgsummary($n, $new_type, $new_time, $new_text)."</li><br />";
    $msg .= "</ul>";

    // Message footer
    $msg .= "<p>".$locale['AN114']."</p>";
    $msg .= "<p><strong><i>".$settings['siteusername']."</i></strong></p>";
    if ($autonews_settings['banner_bottom'] <> '' && file_exists(IMAGES.$autonews_settings['banner_bottom'])) $msg .= "<p><img src='".$settings['siteurl']."images/".$autonews_settings['banner_bottom']."' /></p>";
    $msg .= "<hr><small><strong>Mail generated by <a href='http://www.php-fusion.dk' target='_SELF'>autonews/PHP-Fusion</a>  on ". date($locale['AN010'], $autonews_settings['ts_thissend'])."</strong> - <a href = '".INFUSIONS."autonews/autonews_subscribe.php?s=0&r=".BASEDIR."edit_profile.php'>".sprintf($locale['AN121'], $settings['sitename'])."</a></small>";  
    $msg .= $autonews_params['html_end'];
  }
  
  return $msg;
}

// Utility function to create summary of not printed items
function msgsummary($start, &$new_type, &$new_time, &$new_text)
{
	global $locale, $settings;
	global $autonews_data;
	
  $sepchar = ', ';
  
  // Count not printed messages (from $start to end)
  foreach ($autonews_data as $item)
  {
    $summary[$item['id']] = 0;
  }
  
  for ($i = $start, $end = count($new_time); $i < $end; $i++)
  {
    if ($autonews_data[$new_type[$i]]['type1'] <> '') $summary[$new_type[$i]]++;
  }
  
  // Build tags for each type, which is present
  foreach ($summary as $key => $item)
  {
    if ($item > 0) $tags[] = $item." ".($item == 1? $autonews_data[$key]['type1']: $autonews_data[$key]['type2']);
  }
  
  // Combine it to one string
  if (count($tags) == 1)
  {
    $msg = $tags[0];
  }
  else
  {
    $last = array_pop($tags);
    $msg = implode($sepchar, $tags).$sepchar.$locale['AN117']." ".$last;
  }
  
  $msg = sprintf($locale['AN116'], $msg, "<a href='".$settings['siteurl']."'>".$settings['sitename']."</a>");
  return $msg;
}

// Utility function to format link
function pagelink($type, $id, $text)
{
  global $autonews_params, $settings;
  
  $types = array( 'U'   => 'profile.php?lookup=',
                  'N'   => 'news.php?readmore=',
                  'N0'   => 'news.php',
                  'A'   => 'articles.php?article_id=',
                  'PA'  => ($autonews_params['hsgallery']? 'infusions/hsgallery_panel/': '').'photogallery.php?album_id=',
                  'P'   => ($autonews_params['hsgallery']? 'infusions/hsgallery_panel/': '').'photogallery.php?photo_id=',
									'FF'	=> 'forum/viewforum.php?forum_id=',
									'FT'	=> 'forum/viewthread.php?thread_id=',
									'D'		=> 'downloads.php?cat_id=',
									'W'		=> 'weblinks.php?cat_id=',
									'S'		=> 'infusions/shoutbox_panel/shoutbox_archive.php'
									);
  
  return isNum($id) && array_key_exists($type, $types)? "<a href= '".$settings['siteurl'].$types[$type].($id > 0? $id: '')."'>".$text."</a>": $id;  
}

// Utility function to count and return the number of receivers
function reclist_count()
{
	if ($result = dbquery("SELECT COUNT(*) FROM ".DB_USERS." WHERE user_autonews = '1';"))
	{
		$rtn = mysql_result($result, 0);
	}
  else
  {
		$rtn = FALSE;
	}
  return $rtn;
}

// Utility function to delete $n (or all if $n = 0) receivers from the list
function reclist_delete($n = 0)
{
  $limit = ($n == 0? "": " LIMIT ".$n);
  dbquery("DELETE FROM ".DB_AUTONEWS_TO." ORDER BY to_user".$limit.";");

}

// Utility function that returns an array of the next $n receivers (or all if $n = 0)
// and deletes them from the list (if $delete = TRUE)
function reclist_get($n = 0, $delete = TRUE)
{
  $to = array(); 
  $limit = ($n == 0? "": " LIMIT ".$n);
  $query = "SELECT * FROM ".DB_AUTONEWS_TO." ORDER BY to_user".$limit.";";
  if ($result = dbquery($query))
  {
    while ($data = dbarray($result))
    {
      $to[] = $data['to_mail'];
      //???$to[] = $data['to_user']."&lt;".$data['to_mail']."&gt;";
    }
    if ($delete) reclist_delete($n);
  }
  return $to;
}

// Utility function to empty and set a new list of receivers
function reclist_set()
{
  dbquery("TRUNCATE ".DB_AUTONEWS_TO." ;");
  dbquery("INSERT INTO ".DB_AUTONEWS_TO." SELECT user_name, user_email FROM ".DB_USERS." WHERE user_autonews = '1' ORDER BY user_name;");
  return reclist_count();
}

// Equivalent to groupaccess, but assuming rights as a user
function useraccess($field) 
{
	return "($field='0' OR $field='101')";
}

// Bit functions
function bit_init()
{
  return 0;
}

function bit_isset($value, $n)
{
  return ($value & (1<<$n))? TRUE: FALSE;
}

function bit_set(&$value, $n, $set = 1) 
{
  if ($set == 1) $value = ($value | (1<<$n));
  if ($set == 0) $value = ($value & ~(1<<$n));
  return $value;
}
?>
